Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.jasypt.encryption.pbe
Class StandardPBEBigDecimalEncryptor

    Object
      org.jasypt.encryption.pbe.StandardPBEBigDecimalEncryptor

All Implemented Interfaces:
  BigDecimalEncryptor, CleanablePasswordBased, PasswordBased, PBEBigDecimalCleanablePasswordEncryptor, PBEBigDecimalEncryptor

    public final class StandardPBEBigDecimalEncryptor

extends Object
implements PBEBigDecimalCleanablePasswordEncryptor

Standard implementation of the `PBEBigDecimalEncryptor` interface. This class lets the user specify the algorithm (and provider) to be used for encryption, the password to use, the number of hashing iterations and the salt generator that will be applied for obtaining the encryption key.

Important: The size of the result of encrypting a number, depending on the algorithm, may be much bigger (in bytes) than the size of the encrypted number itself. For example, encrypting a 4-byte integer can result in an encrypted 16-byte number. This can lead the user into problems if the encrypted values are to be stored and not enough room has been provided.

This class is thread-safe.

Configuration

The algorithm, provider, password, key-obtention iterations and salt generator can take values in any of these ways:

- Using its default values (except for password).
- Setting a ``PBEConfig`` object which provides new configuration values.
- Calling the corresponding `setAlgorithm(...)`, `setProvider(...)`, `setProviderName(...)`, `setPassword(...)`, `setKeyObtentionIterations(...)` or `setSaltGenerator(...)` methods.

And the actual values to be used for initialization will be established by applying the following priorities:

1. First, the default values are considered (except for password).
2. Then, if a ``PBEConfig`` object has been set with `setConfig(...)`, the non-null values returned by its `getX()` methods override the default values.
3. Finally, if the corresponding `setX(...)` method has been called on the encryptor itself for any of the configuration parameters, the values set by these calls override all of the above.

Initialization

Before it is ready to encrypt, an object of this class has to be initialized. Initialization happens:

- When `initialize()` is called.
- When `encrypt(...)` or `decrypt(...)` are called for the first time, if `initialize()` has not been called before.

Once an encryptor has been initialized, trying to change its configuration will result in an `AlreadyInitializedException` being thrown.

Usage

An encryptor may be used for:

- Encrypting messages, by calling the `encrypt(...)` method.
- Decrypting messages, by calling the `decrypt(...)` method.

If a random salt generator is used, two encryption results for the same message will always be different (except in the case of random salt coincidence). This may enforce security by difficulting brute force attacks on sets of data at a time and forcing attackers to perform a brute force attack on each separate piece of encrypted data.

To learn more about the mechanisms involved in encryption, read PKCS #5: Password-Based Cryptography Standard.

Since:
  1.2
Author:
  Daniel Fernández

Constructor Summary
`StandardPBEBigDecimalEncryptor()` Creates a new instance of `StandardPBEBigDecimalEncryptor`.

Method Summary
`java.math.BigDecimal` | `decrypt(java.math.BigDecimal encryptedMessage)` Decrypts a message using the specified configuration.
`java.math.BigDecimal` | `encrypt(java.math.BigDecimal message)` Encrypts a message using the specified configuration.
`void` | `initialize()` Initialize the encryptor.
`boolean` | `isInitialized()` Returns true if the encryptor has already been initialized, false if not. Initialization happens:
`void` | `setAlgorithm(String algorithm)` Sets the algorithm to be used for encryption, like `PBEWithMD5AndDES`.
`void` | `setConfig(PBEConfig config)` Sets a ``PBEConfig`` object for the encryptor.
`void` | `setKeyObtentionIterations(int keyObtentionIterations)` Set the number of hashing iterations applied to obtain the encryption key.
`void` | `setPassword(String password)` Sets the password to be used.
`void` | `setPasswordCharArray(char[] password)` Sets the password to be used, as a char[].
`void` | `setProvider(java.security.Provider provider)` Sets the security provider to be asked for the encryption algorithm.
`void` | `setProviderName(String providerName)` Sets the name of the security provider to be asked for the encryption algorithm.
`void` | `setSaltGenerator(SaltGenerator saltGenerator)` Sets the salt generator to be used.

Methods inherited from class Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### StandardPBEBigDecimalEncryptor

    public StandardPBEBigDecimalEncryptor()

  Creates a new instance of `StandardPBEBigDecimalEncryptor`.

Method Detail

### setConfig

    public void setConfig(PBEConfig config)

  Sets a ``PBEConfig`` object for the encryptor. If this config object is set, it will be asked values for:

  - Algorithm
  - Security Provider (or provider name)
  - Password
  - Hashing iterations for obtaining the encryption key
  - Salt generator

  The non-null values it returns will override the default ones, and will be overriden by any values specified with a `setX` method.

  Parameters:
    `config` - the `PBEConfig` object to be used as the source for configuration parameters.

### setAlgorithm

    public void setAlgorithm(String algorithm)

  Sets the algorithm to be used for encryption, like `PBEWithMD5AndDES`.

  This algorithm has to be supported by your JCE provider (if you specify one, or the default JVM provider if you don't) and, if it is supported, you can also specify mode and padding for it, like `ALGORITHM/MODE/PADDING`.

  Parameters:
    `algorithm` - the name of the algorithm to be used.

### setPassword

    public void setPassword(String password)

  Sets the password to be used.

  There is no default value for password, so not setting this parameter either from a `PBEConfig` object or from a call to `setPassword` will result in an EncryptionInitializationException being thrown during initialization.

  Specified by:
    `setPassword` in interface `PasswordBased`
  Parameters:
    `password` - the password to be used.

### setPasswordCharArray

    public void setPasswordCharArray(char[] password)

  Sets the password to be used, as a char[].

  This allows the password to be specified as a cleanable char[] instead of a String, in extreme security conscious environments in which no copy of the password as an immutable String should be kept in memory.

  Important: the array specified as a parameter WILL BE COPIED in order to be stored as encryptor configuration. The caller of this method will therefore be responsible for its cleaning (jasypt will only clean the internally stored copy).

  There is no default value for password, so not setting this parameter either from a `PBEConfig` object or from a call to `setPassword` will result in an EncryptionInitializationException being thrown during initialization.

  Specified by:
    `setPasswordCharArray` in interface `CleanablePasswordBased`
  Parameters:
    `password` - the password to be used.
  Since:
    1.8

### setKeyObtentionIterations

    public void setKeyObtentionIterations(int keyObtentionIterations)

  Set the number of hashing iterations applied to obtain the encryption key.

  This mechanism is explained in PKCS #5: Password-Based Cryptography Standard.

  Parameters:
    `keyObtentionIterations` - the number of iterations

### setSaltGenerator

    public void setSaltGenerator(SaltGenerator saltGenerator)

  Sets the salt generator to be used. If no salt generator is specified, an instance of `RandomSaltGenerator` will be used.

  Parameters:
    `saltGenerator` - the salt generator to be used.

### setProviderName

    public void setProviderName(String providerName)

  Sets the name of the security provider to be asked for the encryption algorithm. This security provider has to be registered beforehand at the JVM security framework.

  The provider can also be set with the `setProvider(Provider)` method, in which case it will not be necessary neither registering the provider beforehand, nor calling this `setProviderName(String)` method to specify a provider name.

  Note that a call to `setProvider(Provider)` overrides any value set by this method.

  If no provider name / provider is explicitly set, the default JVM provider will be used.

  Parameters:
    `providerName` - the name of the security provider to be asked for the encryption algorithm.
  Since:
    1.3

### setProvider

    public void setProvider(java.security.Provider provider)

  Sets the security provider to be asked for the encryption algorithm. The provider does not have to be registered at the security infrastructure beforehand, and its being used here will not result in its being registered.

  If this method is called, calling `setProviderName(String)` becomes unnecessary.

  If no provider name / provider is explicitly set, the default JVM provider will be used.

  Parameters:
    `provider` - the provider to be asked for the chosen algorithm
  Since:
    1.3

### isInitialized

    public boolean isInitialized()

  Returns true if the encryptor has already been initialized, false if not.
  Initialization happens:

  - When `initialize` is called.
  - When `encrypt` or `decrypt` are called for the first time, if `initialize` has not been called before.

  Once an encryptor has been initialized, trying to change its configuration will result in an `AlreadyInitializedException` being thrown.

  Returns:
    true if the encryptor has already been initialized, false if not.

### initialize

    public void initialize()

  Initialize the encryptor.

  This operation will consist in determining the actual configuration values to be used, and then initializing the encryptor with them.
  These values are decided by applying the following priorities:

  1. First, the default values are considered (except for password).
  2. Then, if a ``PBEConfig`` object has been set with `setConfig`, the non-null values returned by its `getX` methods override the default values.
  3. Finally, if the corresponding `setX` method has been called on the encryptor itself for any of the configuration parameters, the values set by these calls override all of the above.

  Once an encryptor has been initialized, trying to change its configuration will result in an `AlreadyInitializedException` being thrown.

  Throws:
    `EncryptionInitializationException` - if initialization could not be correctly done (for example, no password has been set).

### encrypt

    public java.math.BigDecimal encrypt(java.math.BigDecimal message)

  Encrypts a message using the specified configuration.

  The resulting BigDecimal will have the same scale as the original one (although the total number of bytes will be higher).

  Important: The size of the result of encrypting a number, depending on the algorithm, may be much bigger (in bytes) than the size of the encrypted number itself. For example, encrypting a 4-byte integer can result in an encrypted 16-byte number. This can lead the user into problems if the encrypted values are to be stored and not enough room has been provided.

  The mechanisms applied to perform the encryption operation are described in PKCS #5: Password-Based Cryptography Standard.

  This encryptor uses a salt for each encryption operation. The size of the salt depends on the algorithm being used. This salt is used for creating the encryption key and, if generated by a random generator, it is also appended unencrypted at the beginning of the results so that a decryption operation can be performed.

  If a random salt generator is used, two encryption results for the same message will always be different (except in the case of random salt coincidence). This may enforce security by difficulting brute force attacks on sets of data at a time and forcing attackers to perform a brute force attack on each separate piece of encrypted data.

  Specified by:
    `encrypt` in interface `BigDecimalEncryptor`
  Parameters:
    `message` - the BigDecimal message to be encrypted
  Returns:
    the result of encryption
  Throws:
    `EncryptionOperationNotPossibleException` - if the encryption operation fails, ommitting any further information about the cause for security reasons.
    `EncryptionInitializationException` - if initialization could not be correctly done (for example, no password has been set).

### decrypt

    public java.math.BigDecimal decrypt(java.math.BigDecimal encryptedMessage)

  Decrypts a message using the specified configuration.

  The mechanisms applied to perform the decryption operation are described in PKCS #5: Password-Based Cryptography Standard.

  If a random salt generator is used, this decryption operation will expect to find an unencrypted salt at the beginning of the encrypted input, so that the decryption operation can be correctly performed (there is no other way of knowing it).

  Specified by:
    `decrypt` in interface `BigDecimalEncryptor`
  Parameters:
    `encryptedMessage` - the BigDecimal message to be decrypted
  Returns:
    the result of decryption
  Throws:
    `EncryptionOperationNotPossibleException` - if the decryption operation fails, ommitting any further information about the cause for security reasons.
    `EncryptionInitializationException` - if initialization could not be correctly done (for example, no password has been set).

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2014 The JASYPT team. All Rights Reserved.